  /*
  'USING HALF-FLOAT NORMALS
  sub ConeNorm(float nx,ny,nz,xb,xe,ry,rz)
  ========================================
  'Configured As Front Face
 'float xtb=xb*.5,xte=xe*.5  'cutting segment
  float xtb=.5,xte=.5*xe/xb  'best use of texture
 'float xtb=.5,xte=.5        'use whole texture
  glBegin GL_QUADS
  '
  indexbase 0
  float f[8] : GLshort h[8]
  f={-nx,ny,nz,0,nx,ny,nz}
  FloatToHalfFloat(@f,@h,8)
  '
  glNormal3hv  h[0] : glTexCoord2f .5-xtb , 0.0 : glVertex3f -xb , 0  , 1.0  
  glNormal3hv  h[4] : glTexCoord2f .5+xtb , 0.0 : glVertex3f  xb , 0  , 1.0 
  glNormal3hv  h[4] : glTexCoord2f .5+xte , ry  : glVertex3f  xe , ry , rz 
  glNormal3hv  h[0] : glTexCoord2f .5-xte , ry  : glVertex3f -xe , ry , rz
  glEnd
  end sub
  */
  '
  /*
  sub ConeFaces(sys n,float rr,ry,sm)
  ===================================
  'NFACETS  R2/R1  RY RX=1  Y=1
  float nx,ny,nz,rx,a,rs,ra
  sys i
  a=360/n
  rx=tan(pi/n)
  rs=ry*ry+rr*rr
  ra=sqr(rs)
  if ra then ny=rr/ra else ny=1.0  '0..1
  nz=1.0-ny '1..0
  nx=rx*nz*sm
  for i=1 to n
    ConeNorm nx,ny,nz,rx,rx*rr,ry,rr
    glRotatef a,0,1,0 'anticlockwise
  next
  end sub
  */
  '
  /*
  sub ConeNorm(float nx,ny,nz,xb,xe,ry,rz)
  ========================================
  'Configured As Front Face
 'float xtb=xb*.5,xte=xe*.5  'cutting segment
  float xtb=.5,xte=.5*xe/xb  'best use of texture
 'float xtb=.5,xte=.5        'use whole texture
  glBegin GL_QUADS
  glNormal3f -nx,ny,nz : glTexCoord2f .5-xtb , 0.0 : glVertex3f -xb , 0  , 1.0  
  glNormal3f  nx,ny,nz : glTexCoord2f .5+xtb , 0.0 : glVertex3f  xb , 0  , 1.0 
  glNormal3f  nx,ny,nz : glTexCoord2f .5+xte , ry  : glVertex3f  xe , ry , rz 
  glNormal3f -nx,ny,nz : glTexCoord2f .5-xte , ry  : glVertex3f -xe , ry , rz
  glEnd
  end sub
  */


  sub ConeFaces(sys n,float rr,ry,sm,optional sys wr)
  ===================================================
  'N FACETS  R2/R1  RY RX=1  Y=1
  float nx,ny,nz,rx,a,b
  a=360/n
  rx=tan(pi/n)
  'SQUARES
  nx=rx*sm
  nz= sqr(1-nx*nx)
  'CALC NORMALS
  if rr=0 then 'CYLINDER
    ny=0
  elseif ry>=1.0 then 'STEEPER CONICS
    ny=rr/ry 'reduced y normal
  else 'rr>0 'FLATTER CONICS
    ny=1 : b=ry/rr : nx*=b : nz*=b 'reduced x z normals
  end if
  '
  sys i, h,k
  if wr=0 then wr=4
  h=n/wr 'wrap=2 wrap texture twice
  float xt1,xt2,sx
  float j=0, m=wr/n, sg=1
  sx=rx*rr 'taper
  for i=1 to n
    'ConeNorm nx,ny,nz,rx,rx*rr,ry,rr
    xt1=j*m
    xt2=(j*m)+(m*sg)
    k++
    if k=h then
      sg=-sg
      k=0
    else
      j+=sg 'flip texture mapping
    end if
    glBegin GL_QUADS
      glTexCoord2f xt1, 0  : glNormal3f -nx,ny,nz : glVertex3f -rx , 0  , 1 
      glTexCoord2f xt2, 0  : glNormal3f  nx,ny,nz : glVertex3f  rx , 0  , 1
      glTexCoord2f xt2, ry : glNormal3f  nx,ny,nz : glVertex3f  sx , ry , rr 
      glTexCoord2f xt1, ry : glNormal3f -nx,ny,nz : glVertex3f -sx , ry , rr
      'CAPTURE COORDINATES
      'mvt[g]={xt1,0 ,-nx,ny,nz,-rx,0 ,1 } : g+=8
      'mvt[g]={xt2,0 , nx,ny,nz, rx,0 ,1 } : g+=8
      'mvt[g]={xt2,ry, nx,ny,nz, sx,ry,rr} : g+=8
      'mvt[g]={xt1,ry,-nx,ny,nz,-sx,ry,rr} : g+=8
    glEnd
    glRotatef a,0,1,0
  next
  end sub

  sub HemiSpheric(float rw, rh, m)
  ================================
  float s,c,r,r1,r2,x1,x2,y1,y2,z1,z2
  sys e,i,j,st=m
  e=90-st
  for j=0 to e step st
    r=rad(j)    : r1=rw*cos(r) : y1=rh*sin(r)
    r=rad(j+st) : r2=rw*cos(r) : y2=rh*sin(r)
    glBegin GL_QUAD_STRIP
    for i=0 to 360 step st
      r=rad(i)
      c=cos(r) : s=-sin(r)
      x1=r1*c  : z1=r1*s
      x2=r2*c  : z2=r2*s
      glNormal3f x2, y2, z2
      glVertex3f x2, y2, z2
      glNormal3f x1, y1, z1
      glVertex3f x1, y1, z1
    next
    glEnd
  next
  end sub

  sub spheric(float rw,rh,m)
  ==========================
  glPushMatrix
  hemispheric   rw, rh, m
  glRotatef     180,1,0,0
  hemispheric   rw, rh, m
  glPopMatrix
  end sub

  sub CubicSectMap(vector *v,sys n)
  =================================
  'requires (n*3+3)^2 * 4 bytes
  'if n=4 then bytes 15*15*4 = 225*4 = 900 bytes
  sys   i,j
  float st=1/n
  float w,x,y,z
  sys m=n+1
  for j=1 to m
    x=0
    for i=1 to m
      w=1/sqr(x*x+y*y+1.0) '1/(distance to centre of cube)
      'unity radius adjustment
      v={x*w,y*w,w}
      @v+=sizeof vector
      x+=st
    next
    y+=st
  next
  end sub


  sub CubicFace0(sys n)
  ====================
  sys   i,j
  float u,v,w,x,ya,yb,z,sc,su,sv
  sc=pi/(n*4)
  su=1./n
  sv=su
  float w1,w2,x1,y1,z1,x2,y2,z2,u1,u2,v1,v2
  v=0.
  v1=v
  for j=-n to <n
    x=-1.0
    u= 0.
    u1=u
    if v1+sv<0 or v1+sv>1.0 then sv=-sv
    v2=v1+sv
    glBegin GL_QUAD_STRIP
    ya=tan(j*sc)
    yb=tan(j*sc+sc)
    for i=-n to n
      x=tan(i*sc)
      w1=1/sqr(x*x+ya*ya+1.0) '1/(distance to centre of cube)
      w2=1/sqr(x*x+yb*yb+1.0) '1/(distance to centre of cube)
      'unity radius adjustment
      x1=x*w1
      x2=x*w2
      y1=ya*w1
      y2=yb*w2
      z1=w1
      z2=w2
      glTexCoord2f u1,v2 : glNormal3f x2,y2,z2 : glVertex3f x2,y2,z2
      glTexCoord2f u1,v1 : glNormal3f x1,y1,z1 : glVertex3f x1,y1,z1
      'glTexCoord2f u1,v2 : glNormal3f x2,y2,z2 : glVertex3f x2,y2,z2
      if u1+su<0 or u1+su>1.0 then su=-su
      u1+=su
    next
    glEnd
    v1=v2
  next
  end sub

  function triangulate(float a,b,c,*d,*h)
  =======================================
  d=(a*a+c*c-b*b)/(c*2)
  h=sqrt(a*a-d*d)
  end function

  function pointdist(float x1,y1,z1,x2,y2,z2) as float
  ====================================================
  float x,y.z
  x=x2-x1 : y=y2-y1 : z=z2-z1
  return sqrt(x*x+y*y+z*z)
  end function

  function parallelogrid(c,d,h,n)
  ===============================
  sys i
  float sx,sy
  float x1,y1,z1,x2,y2,z2
  float u1,v1,u2,v2,SV
  sx=d/n
  sy=h/n
  u1=0.
  u2=1.
  sv=1./n
  v1=0
  'HORIZONTAL LINES
  for i=0 to n
    glBegin GL_LINES
    x2=x1+c
    v2+=sv
    glTexCoord2f u1,v1 : glNormal3f 0.,0.,1. : glVertex3f x1,y1,0.
    glTexCoord2f u2,v1 : glNormal3f 0.,0.,1. : glVertex3f x2,y2,0.
    glEnd
    x1-=sx
    y1+=sy
    v1=v2
  next
  x1=0
  y1=0
  y2=h
  'SLOPING LINES
  for i=0 to n
    glBegin GL_LINES
    x2=x1-d
    glNormal3f 0.,0.,1. : glVertex3f x1,y1,0.
    glNormal3f 0.,0.,1. : glVertex3f x2,y2,0.
    glEnd
    x1+=sx
  next
  end function

  function NoiseB(float fv) as float
  ==================================
  static double d=1/0xffffffff
  sys v=abs(fv)*1000
  mov eax,v
  rol eax,5
  mul v
  xor eax,0x9595adad
  mul v
  rol eax,3
  mov v,eax
  return d*v 'range +1 to -1
  end function
  '
  sub CubicFace(int n, float ns=0, int mo=0,st=0,en=0)
  ====================================================
  int   i,j
  float u,v,w,x,ya,yb,z,sc,su,sv
  if st=0 and en=0
    st=-n : en=n
  end if
  sc=pi/(n*4)
  su=.5*(en-st)/(n*n)
  'su=1./n
  sv=su
  float w1,w2,x1,y1,z1,x2,y2,z2,u1,u2,v1,v2
  v=st/(n*n)
  v1=v
  for j=st to <en
    u= st/(n*n)
    u1=u
    if v1+sv<0 or v1+sv>1.0 then sv=-sv
    v2=v1+sv
    if not mo
      glBegin GL_QUAD_STRIP
    else
      glBegin GL_LINE_STRIP
    end if
    ya=tan(j*sc)
    yb=tan(j*sc+sc)
    for i=st to en
      x=tan(i*sc)
      w1=sqr(x*x+ya*ya+1.0) '(distance to centre of cube)
      w1=1/(w1+ns*noiseB w1)
      w2=sqr(x*x+yb*yb+1.0) '(distance to centre of cube)
      w2=1/(w2+ns*noiseB w2)
      'radius adjustment
      x1=x*w1
      x2=x*w2
      y1=ya*w1
      y2=yb*w2
      z1=w1
      z2=w2
      glTexCoord2f u1,v2 : glNormal3f x2,y2,z2 : glVertex3f x2,y2,z2
      glTexCoord2f u1,v1 : glNormal3f x1,y1,z1 : glVertex3f x1,y1,z1
      if mo
        glTexCoord2f u1,v2 : glNormal3f x2,y2,z2 : glVertex3f x2,y2,z2
      end if
      if u1+su<0 or u1+su>1.0 then su=-su
      u1+=su
    next
    glEnd
    v1=v2
  next
  end sub


  sub rotatexy(float *x,*y,a)
  ===========================
  double r
  r=hypot(x,y)
  if r=0 then exit sub
  a+=atan(y,x)
  x=r*cos(a)
  y=r*sin(a)
  end sub

  sub Toroid(single major1 , minor1, major2 , minor2, ro, yd)
  ===========================================================
  '   start size       end size         roations displacement
  '
  static as double
  twopi=pi()*2,MajorRes=32,MinorRes=32,iMajorRes=1/32,iMinorRes=1/32,ij
  '
  static as single
  a, b, s, t, x, y, z, nx, ny, nz, gscale,tmc,tmd,tme,major,minor,ja
  '
  static as sys
  i,j,k,ie,je
  '
  ie=MajorRes-1
  je=ro*MajorRes
  ij=1/je
  for i = 0 to ie
    glBegin GL_QUAD_STRIP
    for j = 0 to je
      ja=j*ij
      for k = 1 to 0 step -1
        '
        'SIZE TRANSITION
        major=major1*(1-ja)+major2*ja
        minor=minor1*(1-ja)+minor2*ja
        '
        s = mod( i+k,MajorRes + 0.5)
        t = mod(j,MinorRes)
        '
        'CALCULATE POINT ON SURFACE
        tmd=s*twopi*iMinorRes
        tme=t*twopi*iMajorRes
        tmc=major+minor * cos(tmd)
        x = tmc   * cos(tme)
        y = minor * sin(tmd)
        z = tmc   * sin(tme)
        '
        'CALCULATE SURFACE NORMAL
        nx=x-(major * cos(tme)) 'anchor to minor centre
        nz=z-(major * sin(tme)) '
        ny = y
        glNormal3f nx,ny,nz
        y+=yd*ja 'y helical vertical displacement
        glVertex3f x,y,z
      next
    next
    glend
  next
  end sub


  sub Torus(single major, minor)
  ==============================
  toroid major,minor,major,minor,1,0
  end sub



